/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2011 Gabriele Dini Ciacci <dark.schneider@iol.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on May 10, 2011, 11:40 AM
 */

#ifndef U2D_MATH_H
#define	U2D_MATH_H

#include "boost/numeric/mtl/mtl.hpp"
#include "common/u2d_Math.h"
#include "exceptions.h"

using namespace mtl;

class u2d_Math {
public:
    static dense2D<double> FieldEvaluator(dense2D<double> points, string formulaX, string formulaY) throw (u2d_Size_Missmatch_Exception &, u2d_Parse_Error_Exception &);
    static dense_vector<double> ScalarEvaluator(dense2D<double> points, string formula) throw (u2d_Size_Missmatch_Exception &, u2d_Parse_Error_Exception &);
    static void LinearRGB(float *color, float value, float minValue, float maxValue) throw (u2d_Math_Exception &);

};


#endif	/* U2D_MATH_H */

