/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2011 Gabriele Dini Ciacci <dark.schneider@iol.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on June 8, 2011, 12:14 AM
 */

#ifndef U2D_DISPLAYOBJECT_H
#define	U2D_DISPLAYOBJECT_H

#include <string>
#include <boost/shared_ptr.hpp>

class u2d_DisplayObject {
public:
    virtual void draw() = 0;

    virtual std::string getName() const = 0;

    virtual bool isEnabled() const = 0;
    
    virtual u2d_DisplayObject& enable() = 0;
    virtual u2d_DisplayObject& disable() = 0;
    
private:

};

typedef boost::shared_ptr<u2d_DisplayObject> u2d_DisplayObjectPointer;
#endif	/* U2D_DISPLAYOBJECT_H */

