/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2010 Gabriele Dini Ciacci <dark.schneider@iol.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 16, 2010, 4:31 PM
 */

#ifndef _U2D_LOAD_SCALARFIELD_H
#define	_U2D_LOAD_SCALARFIELD_H

#include <iostream>
#include <string>

#include "boost/numeric/mtl/mtl.hpp"
#include "u2d_load_values.h"
#include "exceptions.h"

class u2d_LoadScalarField : private u2d_LoadValues {
public:
    u2d_LoadScalarField(std::string _filename, bool _lineonesize = true, size_t _suggested_size = 0);
    virtual ~u2d_LoadScalarField();
    mtl::dense_vector<double> getVector();

private:
    void parseValuesFile() throw (u2d_Parse_Error_Exception &);
    void parseSize() throw (u2d_Parse_Error_Exception &);
    void parseElements() throw (u2d_Parse_Error_Exception &);
    mtl::dense_vector<double> read_vector;
    size_t vector_size;
};

#endif	/* _U2D_LOAD_SCALARFIELD_H */

