/*

    umesh2dgui, a GUI for umesh2d grid generator

    Copyright (C) 2010 Gabriele Dini Ciacci <dark.schneider@iol.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Created on April 13, 2010, 6:05 PM
 */

#include "boost/numeric/mtl/mtl.hpp"
#include "u2d_load_values.h"

using namespace std;
using namespace mtl;

u2d_LoadValues::u2d_LoadValues(string _filename, bool _lineonesize, size_t _suggested_size) :
lineonesize(true),
suggested_size(_suggested_size) {
    filename = _filename;
    lineonesize = _lineonesize;
    openValuesFile();
}

u2d_LoadValues::~u2d_LoadValues() {
    closeValuesFile();
}

void u2d_LoadValues::openValuesFile() {
    filestream.open(filename.c_str(), ifstream::out);
}

void u2d_LoadValues::closeValuesFile() {
    if (filestream.is_open()) {
        filestream.close();
    }

}


