#ifndef U2D_GL_H
#define U2D_GL_H

/* 

    umesh2dgui, a GUI for umesh2d grid generator 

    Copyright (C) 2003 Gabriele Dini Ciacci
  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <fltk/gl.h>
#include <fltk/GlWindow.h>
#include <stdio.h>

#include "u2d_core.h"

class u2d_GL : public fltk::GlWindow {
  void draw();
  int handle(int event);

 public:
  u2d_GL(int X, int Y, int W, int H, const char *L);
  void set_prim_list_start(Primitive *prim, int n);

  /* For drawing reference size */
  void guess_ref_size();
  void guess_ref_size(Primitive *);

 private:
  void MyInit();
  void drawgeometry();   // very slow.... 
  void drawprimitive(Primitive *curprim); // this should be changed so it creates a vector with the points
  Primitive *firstprimitive;
  int nprim;
  /* For drawing reference size */
  void set_ref_sizes(double minX, double maxX, double minY, double maxY);
  double ref_minX;
  double ref_maxX;
  double ref_minY;
  double ref_maxY;
};


#endif
